
<#Script to mount Vmware tools on the target VM.

PowerShell Run Syntax in vCommander: "Powershell.exe -ExecutionPolicy RemoteSigned -Command "C:\Scripts\UnMountTools.ps1 -TargetVM '#{target.Name}' -VIServer '#{target.managementServer.displayName}'"

#>

#Input Parameters should not need to be changed
param (
  [Parameter(Mandatory=$True)]      
  [string]$TargetVM = $(Throw "Please provide target VM name "),
  [string]$VIServer = $(Throw "Please provide vCenter server name ")
  )
 
#Please Update the Cred File for your Vcenter
    $vCredFile = 'c:\scripts\vCenter_Credential_Key.xml'   #< vCenter Encrypted Cred File must have access to all vmware management servers

############################################################################################################################

#Remove and re-add the modules    
        $moduleName = "VCommander"
        If (-not (Get-Module -name $moduleName)) {
                        Import-Module -Name $moduleName 
        } else {
                        Remove-Module $moduleName
                        Import-Module -Name $moduleName 
        }
#Connect to vCenter and Disable Cert warnings
        & "C:\Program Files (x86)\VMware\Infrastructure\vSphere PowerCLI\Scripts\Initialize-PowerCLIEnvironment.ps1"
        Set-PowerCLIConfiguration -InvalidCertificateAction ignore -Confirm:$False
        $cred = (New-DecryptCredential -keyFilePath $vCredFile) 
        Connect-VIServer -Server $VIServer -credential $cred
        Write-Host "Connected to $VIServer" 

## Add the VMware snapin so we can do stuff
add-pssnapin VMware.VimAutomation.Core
 
## Mount the tools ISO so we can install them.
get-vm -Name "$TargetVM" | Dismount-Tools 

Write-Host "Unmount tools script completed!"
